Graphics3D 640,480,0,2

Const t_pl1=1,t_cu=2

cu=CreateCube()
ScaleEntity cu,60,60,60
FlipMesh cu
EntityColor cu,100,100,100

piv=CreatePivot()
cam=CreateCamera(piv)
lit=CreateLight() 
RotateEntity lit,45,45,0 
pl1=CreateSphere()
ScaleEntity pl1,3,3,3
EntityRadius pl1,3
EntityColor pl1,0,0,255
MoveEntity cam,0,0,-150

speed#=2
TurnEntity pl1,Rnd(360),Rnd(360),Rnd(360)

EntityType pl1,t_pl1
EntityType cu,t_cu
Collisions t_pl1,t_cu,2,1

PointEntity cam,pl1
MoveMouse(200,200)
While Not KeyHit(1) 
	
	x#=MouseX()
	y#=MouseY()
	
	If y<30 Then TurnEntity piv,1,0,0
	If y>440 Then TurnEntity piv,-1,0,0
	If x<30 Then TurnEntity piv,0,-1,0
	If x>600 Then TurnEntity piv,0,1,0
	
	old_x#=EntityX(pl1)
	old_y#=EntityY(pl1)
	old_z#=EntityZ(pl1)
	
	MoveEntity pl1,0,0,speed
	
	If EntityCollided(pl1,t_cu) Then
		For k=1 To CountCollisions(pl1)

			n_xx#=CollisionNX(pl1,k)
			n_yy#=CollisionNY(pl1,k)
			n_zz#=CollisionNZ(pl1,k)
			
			xx#=EntityX(pl1)-old_x#
			yy#=EntityY(pl1)-old_y#
			zz#=EntityZ(pl1)-old_z#
			
			dot#=xx*n_xx+yy*n_yy+zz*n_zz
			ex#=n_xx*dot
			ey#=n_yy*dot
			ez#=n_zz*dot
			
			xx=xx-ex*2
			yy=yy-ey*2
			zz=zz-ez*2
			
			AlignToVector pl1,xx,yy,zz,3
			MoveEntity pl1,0,0,speed
			Exit
		Next
	EndIf

	UpdateWorld
	RenderWorld
	Flip 

Wend 
End
